#ifndef _UTIL_H
#define _UTIL_H

#define NR_END (1)
#define FREE_ARG void*


#ifdef _UTIL_C
	XTYPE* vector(UINT32 length);
	UINT32* uint32vector(UINT32 length);
	BIT_TYPE* bitTypeVector(UINT32 length);
	XFLXTYPE* xflxvector(UINT32 length);
	XTYPE** xtypeMatrix(UINT32 nRows, UINT32 nCols);
	BIT_TYPE** bitTypeMatrix(UINT32 nRows, UINT32 nCols);
	void nrerror(char error_text[]);
	void freeVector(XTYPE* vector);
	void freexflxVector(XFLXTYPE* vector);
	void freeuint32Vector(UINT32* vector);
	void freebitTypeVector(BIT_TYPE* vector);
	void freextypeMatrix(XTYPE** mat, UINT32 nRows);
	void freeuint32Matrix(UINT32** mat, UINT32 nRows);
	void writeMat( XTYPE **mat, BIT_TYPE **bitArray, UINT32 rowSize );
	void writeMat2( XTYPE **mat, UINT32 **bitArray, UINT32 rowSize );
	void writeStoickMat( XTYPE** sMat, UINT32 nrows, UINT32 ncols );
#else
	extern XTYPE* vector(UINT32 length);
	extern UINT32* uint32vector(UINT32 length);
	extern BIT_TYPE* bitTypeVector(UINT32 length);
	extern XFLXTYPE* xflxvector(UINT32 length);
	extern XTYPE** xtypeMatrix(UINT32 nRows, UINT32 nCols);
	extern BIT_TYPE** bitTypeMatrix(UINT32 nRows, UINT32 nCols);
	extern void nrerror(char error_text[]);
	extern void freeVector(XTYPE* vector);
	extern void freexflxVector(XFLXTYPE* vector);
	extern void freeuint32Vector(UINT32* vector);
	extern void freebitTypeVector(UINT32* vector);
	extern void freextypeMatrix(XTYPE** mat, UINT32 nRows);
	extern void freeuint32Matrix(UINT32** mat, UINT32 nRows);	
	extern void writeMat( XTYPE **mat, BIT_TYPE **bitArray, UINT32 rowSize);
	extern void writeMat2( XTYPE **mat, UINT32 **bitArray, UINT32 rowSize );
	extern writeStoickMat( XTYPE** sMat, UINT32 nrows, UINT32 ncols );
#endif



#endif /*end of file*/
